; core.asm
;
; A few, basic words. Not everything in the core dictionary.

%macro next 0
	lodsd				; eax = word to execute
	jmp	eax			; increase IP, jump to word
%endmacro

core_header 06,_nest,"nest",flag_none
_nest:
	xchg	ebp,esp			; use return stack
	push	esi			; push IP to it
	xchg	ebp,esp			; use data stack
	pop	esi			; pop IP from it
	next

; er.. you don't want to CALL this.
;
; esi = where to return to
; eax = where to start execution
_nest_to:
	xchg	ebp,esp
	push	esi
	xchg	ebp,esp
	mov	esi,eax
	next

core_header 08,_exit,"exit",flag_none
_exit:
	mov	esi,[ebp]		; pop IP from return stack
	add	ebp,byte 4
	next

core_header 33,_dolit,"dolit",flag_none
_dolit:
	lodsd				; eax = literal
	push	ebx			; push old TOS
	xchg	eax,ebx			; new TOS becomes literal
	next

core_header 38,_dovariable,"dovariable",flag_none
_dovariable:
	xchg	ebx,[esp]		; get IP, push TOS, push IP
	next

%if 0
core_header 35,_doconst,"doconst",flag_none
_doconst:
	xchg	ebx,[esp]		; get IP, push TOS, push IP
	mov	ebx,[ebx]		; new TOS becomes constant
	next
%endif

core_header 34,_donext,"donext",flag_none
_donext:
	lodsd				; eax = address to jump bjump back to
	dec	dword[ebp]		; decread count word by 1
	jz	.break			; break look if zero
	xchg	eax,esi			; non-zero, loop
	next
.break:	add	ebp,byte 4		; r>drop
	next

core_header 0b,_execute,"execute",flag_none
_execute:
	xchg	ebx,[esp]		; magic
	ret

