; idt.asm
;
; Here we deal with interrupts.

idt_init:
	xor	eax,eax
.next:	mov	ebx,idt_dummy_int
	call	idt_set_int
	inc	eax
	cmp	eax,0x100
	jb	.next

	mov	eax,8
	mov	ebx,idt_dummy_errint
	call	idt_set_int
	mov	eax,10
	mov	ebx,idt_dummy_errint
	call	idt_set_int
	mov	eax,11
	mov	ebx,idt_dummy_errint
	call	idt_set_int
	mov	eax,12
	mov	ebx,idt_dummy_errint
	call	idt_set_int
	mov	eax,13
	mov	ebx,idt_dummy_errint
	call	idt_set_int
	mov	eax,14
	mov	ebx,idt_dummy_errint
	call	idt_set_int
	mov	eax,17
	mov	ebx,idt_dummy_errint
	call	idt_set_int

	lidt	[idt_descriptor]
	ret

idt_dummy_int:
	iret

idt_dummy_errint:
	add	esp,4
	iret

; eax = interrupt number
; ebx = pointer to interrupt function
idt_set_int:
	mov	word[idt+(eax*8)],bx
	shr	ebx,16
	mov	word[idt+(eax*8)+6],bx
	mov	dword[idt+(eax*8)+2],0x8e000008
	ret

idt_descriptor:
.size		dw	0x7ff
.pointer	dd	idt

