; ipcforth.asm
;
; Glue between IPC and Forth.

; ipc-send ( data-struct pid -- )
core_header 0c,_ipc_send,"ipc-send",flag_none
_ipc_send:
	xchg	eax,ebx			; eax = pid
	pop	ebx			; ebx = struct
	push	esi
	mov	ecx,[ebx+0]
	mov	edx,[ebx+4]
	mov	esi,[ebx+12]
	mov	ebx,[ebx+8]
	call	ipc_send_message
	pop	esi
	pop	ebx			; pop TOS
	next

; ipc-poll ( -- true|false )
core_header 0c,_ipc_poll,"ipc-poll",flag_none
_ipc_poll:
	push	ebx
	call	ipc_check_message
	or	eax,eax
	jz	.false
	mov	ebx,-1
	next
.false:	xor	ebx,ebx
	next

; ipc-recv ( data-struct -- pid )
core_header 0c,_ipc_recv,"ipc-recv",flag_none
_ipc_recv:
	push	esi
	push	ebp
	mov	ebp,ebx
	push	edi

	call	ipc_receive_message
	mov	[ebp+0],ecx
	mov	[ebp+4],edx
	mov	[ebp+8],ebx
	mov	[ebp+12],esi
	mov	ebx,edi

	pop	edi
	pop	ebp
	pop	esi
	next

