; irq.asm
;
; Here is where you enable/disable interrupts.

irq_init:
	mov	al,0x11
	out	0x20,al

	mov	al,0x20
	out	0x21,al
	mov	al,0x04
	out	0x21,al
	mov	al,0x01
	out	0x21,al
	mov	al,0xff
	out	0x21,al

	mov	al,0x11
	out	0xa0,al

	mov	al,0x28
	out	0xa1,al
	mov	al,0x02
	out	0xa1,al
	mov	al,0x01
	out	0xa1,al
	mov	al,0xff
	out	0xa1,al

	mov	al,0xff
	out	0x21,al
	out	0xa1,al

	ret

; cl = irq
irq_enable:
	cmp	cl,8
	jb	.master
	sub	cl,8
	mov	ah,1
	shl	ah,cl
	xor	ah,0xff
	in	al,0xa1
	and	al,ah
	out	0xa1,al
	ret
.master:
	mov	ah,1
	shl	ah,cl
	xor	ah,0xff
	in	al,0x21
	and	al,ah
	out	0x21,al
	ret

; cl = irq
irq_disable:
	cmp	cl,8
	jb	.master
	sub	cl,8
	mov	ah,1
	shl	ah,cl
	in	al,0xa1
	or	al,ah
	out	0xa1,al
	ret
.master:
	mov	ah,1
	shl	ah,cl
	in	al,0x21
	or	al,ah
	out	0x21,al
	ret

; ax = bit map (IRQ n equals to bit n, 1 = disabled)
irq_set_mask:
	out	0x21,al
	mov	al,ah
	out	0xa1,al
	ret

