; kbdforth.asm
;
; Glue to kbd.asm and a few other keyboard-related words.
; The variable definitions "keymap", "key-special" and "key-status"
; are in kbd.asm

; key ( -- c )
core_header 39,_key,"key",flag_none
_key:
	push	ebx
	call	kbd_read
	movzx	ebx,al
	next

; key-scan ( -- scancode ascii )
core_header 3e,_keyscan,"key-scan",flag_none
_keyscan:
	push	ebx
	call	kbd_read
	movzx	ebx,al
	movzx	eax,ah
	push	eax
	next

; key? ( -- true | false )
core_header 3a,_keyc,"key?",flag_none
_keyc:
	push	ebx
	call	kbd_poll
	xchg	eax,ebx
	next

; key-write ( c -- )
core_header 3f,_key_write,"key-write",flag_none
_key_write:
	mov	al,bl
	call	kbd_write
	pop	ebx
	next

; accept ( s maxlength -- )
core_header 10,_accept,"accept",flag_none
_accept:
	pop	ecx
	mov	edx,ecx			; edx = address to count byte
	inc	ecx			; ecx = address to first character
.read:
	call	kbd_read
	cmp	al,0x0a			; new line?
	jz	.done			; yes, we're done
	cmp	al,0x08			; backspace?
	jz	.erase			; yes, erase...
	push	ecx
	sub	ecx,edx
	dec	ecx			; ecx = current length of string
	cmp	ecx,ebx			; compare to maximum length
	pop	ecx
	jnb	.read			; if not below, read next char
	mov	[ecx],al
	inc	ecx			; otherwise, just store byte
	push	ebx
	push	edx
	mov	ebx,main_screen
	mov	dl,al
	call	crt_put_char		; ...print it...
	pop	edx
	pop	ebx
	jmp	short .read		; and read next character
.erase:
	mov	eax,ecx
	dec	eax
	cmp	eax,edx			; are we at position 0?
	jz	.read			; yes, don't do anything
	dec	ecx			; no, back one step
	push	ebx
	mov	ebx,main_screen
	call	crt_move_cursor_back	; move cursor back
	pop	ebx
	jmp	short .read		; and read next character
.done:
	sub	ecx,edx
	dec	ecx
	mov	[edx],cl		; store count byte
	mov	ebx,main_screen
	mov	dl,0x20
	call	crt_put_char
	pop	ebx
	next

