; math.asm
;
; Words to do simple arithmetic.

core_header 17,_add,"+",flag_none
_add:
	pop	eax			; eax = NOS
	add	ebx,eax			; add to TOS
	next

core_header 1b,_sub,"-",flag_none
_sub:
	sub	[esp],ebx		; subtract TOS from NOS
	pop	ebx			; pop TOS
	next

core_header 15,_mul,"*",flag_none
_mul:
	pop	eax			; eax = NOS
	mul	ebx			; multuply with TOS
	xchg	eax,ebx			; store result on TOS
	next

core_header 1f,_div,"/",flag_none
_div:
	pop	eax			; eax = NOS
	xor	edx,edx			; edx:eax = NOS
	div	ebx			; divide by TOS
	xchg	eax,ebx			; store result on TOS
	next

core_header 15,_mod,"mod",flag_none
_mod:
	pop	eax			; eax = NOS
	xor	edx,edx			; edx:eax = NOS
	div	ebx			; divide by TOS
	mov	ebx,edx			; store result on TOS
	next

core_header 1a,_divmod,"/mod",flag_none
_divmod:
	pop	eax			; eax = NOS
	xor	edx,edx			; edx:eax = NOS
	div	ebx			; divide by TOS
	push	eax			; quotient on NOS
	mov	ebx,edx			; store remainder on TOS
	next

core_header 08,_muldiv,"/*",flag_none
_muldiv:
	pop	eax			; eax = NOS
	pop	edx			; edx = 3rd element
	mul	edx			; edx:eax = edx * eax
	div	ebx			; eax = edx:eax / ebx
	xchg	eax,ebx			; store result on TOS
	next

core_header 23,_and,"and",flag_none
_and:
	pop	eax			; eax = NOS
	and	ebx,eax			; TOS = TOS and NOS
	next

core_header 22,_or,"or",flag_none
_or:
	pop	eax			; eax = NOS
	or	ebx,eax			; TOS = TOS or NOS
	next

core_header 01,_xor,"xor",flag_none
_xor:
	pop	eax			; eax = NOS
	xor	ebx,eax			; TOS = TOS xor NOS
	next

core_header 2a,_shl,"<<",flag_none
_shl:
	mov	cl,bl			; cl = TOS
	pop	ebx			; pop TOS
	shl	ebx,cl			; shift left
	next

core_header 36,_shr,">>",flag_none
_shr:
	mov	cl,bl			; cl = TOS
	pop	ebx			; pop TOS
	shr	ebx,cl			; shift right
	next

core_header 22,_rl,"rl",flag_none
_rl:	mov	cl,bl
	pop	ebx
	rol	ebx,cl
	next

core_header 2e,_rr,"rr",flag_none
_rr:	mov	cl,bl
	pop	ebx
	ror	ebx,cl
	next

core_header 05,_neg,"neg",flag_none
_neg:
	neg	ebx
	next

core_header 19,_not,"not",flag_none
_not:
	not	ebx
	next

core_header 1c,_1add,"1+",flag_none
_1add:
	inc	ebx
	next

core_header 20,_1sub,"1-",flag_none
_1sub:
	dec	ebx
	next

core_header 28,_4add,"4+",flag_none
_4add:
	add	ebx,byte 4
	next

core_header 2c,_4sub,"4-",flag_none
_4sub:
	sub	ebx,byte 4
	next

core_header 20,_2add,"2+",flag_none
_2add:
	add	ebx,byte 2
	next

core_header 24,_2sub,"2-",flag_none
_2sub:
	sub	ebx,byte 2
	next

core_header 1e,_2mul,"2*",flag_none
_2mul:
	shl	ebx,1
	next

core_header 28,_2div,"2/",flag_none
_2div:
	shr	ebx,1
	next

core_header 26,_4mul,"4*",flag_none
_4mul:
	shl	ebx,2
	next

core_header 30,_4div,"4/",flag_none
_4div:
	shr	ebx,2
	next

