; mm.asm
;
; Taken from Primula and modified a little.

; 2003-12-28
; Looking through the whole project now. I can't believe I used to use
; this piece of shit! It is actually the Primula MM, which was ported from
; the BozOS MM in..uhm..a long time ago.

; As of 2003-10-27 not used anymore.
; R.I.P.

;
;
; Contains functions to allocate and free memory blocks.
;
;
; Memory table entry
;
; start address		dword
; size of block		dword
; status		byte
;  0 = not used
;  1 = free
;  2 = used
;

%define MEM_STATUS_UNUSED	0
%define MEM_STATUS_FREE		1
%define MEM_STATUS_USED		2

; mem_init
;
; initialized memory allocation tables.
;
; returns:
; all registers unchanged

mem_init:
	push	eax
	push	ecx
	push	edi

	mov	eax,[memory_size]
	shl	eax,10
	add	eax,0x100000
	mov	[mem_high_end],eax

	mov	edi,mem_table		; let's fill the memory table
	xor	eax,eax			; with zeroes
	mov	ecx,mem_table_size*9
	rep	stosd

	mov	edi,mem_table

	mov	eax,dword[mem_high_start]
	mov	dword[edi],eax		; start of first memory block
	mov	ecx,dword[mem_high_end]
	sub	ecx,eax			; size = end - start (yay!)
	mov	dword[edi+4],ecx	; size of first memory block
	mov	byte[edi+8],MEM_STATUS_FREE

	mov	dword[mem_table_max],9

	pop	edi
	pop	ecx
	pop	eax
	ret

; mem_alloc
;
; allocates memory
;
; eax = requested size
;
; returns:
; esi = pointer to allocated memory

mem_alloc:
	pushf
	cli
	push	ecx
	push	edx

	mov	ecx,mem_table
.try_block:
	; now make sure the block is free, and large enough
	; first of all, is it free?
	cmp	byte[ecx+8],MEM_STATUS_FREE
	jnz	.next_block		; no, try with next block
	cmp	dword[ecx+4],eax	; is the block large enough?
	jb	.next_block		; nope, try next block
	jnz	.resize			; if the block is too big, resize it

	; since the block is just the size we want, just mark it as used
	mov	byte[ecx+8],MEM_STATUS_USED
	mov	esi,dword[ecx]
	jmp	short .quit
.resize:
	mov	edx,mem_table
	add	edx,dword[mem_table_max]; get an unused memory table entry
	cmp	edx,mem_table+mem_table_size
	jnb	.error			; if nothing found, quit

	; now subtract the amount of memory we want from the free block
	sub	dword[ecx+4],eax

	mov	esi,dword[ecx]		; the start of the free block
	mov	dword[edx],esi		; the start of the new block
	add	dword[ecx],eax		; add size of requested amount of mem
					; to the start of the old block.
	mov	dword[edx+4],eax	; set size of the new block.
	mov	byte[edx+8],MEM_STATUS_USED
					; mark it as used
	add	dword[mem_table_max],9	; make sure to resize mem_table
.quit:
	pop	edx
	pop	ecx
	popf
	ret
.error:
	xor	esi,esi
	jmp	short .quit
.next_block:
	add	ecx,byte 9
	cmp	ecx,(mem_table_size*9)+mem_table
					; check if we've reached last block
	jb	.try_block		; nope, check this block
	xor	esi,esi			; return NULL
	jmp	short .quit

; mem_free
;
; frees the allocated memory block at eax
;
; eax = memory offset to free
;
; returns:
; eax = 0 if everything's OK

mem_free:
	pushf
	cli
	push	ecx
	push	edx

	mov	ecx,mem_table
.try_next:
	cmp	dword[ecx],eax		; is this the mem_table entry
	jnz	.nope			; we're looking for?
	; now we've found the block to free, simply mark is as 'free'
	; and defrag the table
	mov	byte[ecx+8],MEM_STATUS_FREE
	call	mem_defrag
	xor	eax,eax			; return 0 (OK)
	jmp	.quit
.nope:
	add	ecx,9			; go to the next mem_table entry
	mov	edx,dword[mem_table_max]
	add	edx,mem_table		; calculate the end of the memory table
	cmp	ecx,edx			; have we reached the end?
	jb	.try_next		; no, try this entry too
	mov	al,1			; make eax non-zero
.quit:
	pop	edx
	pop	ecx
	popf
	ret

; mem_defrag
;
; used by mem_free to defragment the memory table
;
; returns:
; all registers unchanged

mem_defrag:
	push	eax
	push	ecx
	push	edx
	push	ebx
	push	esi
	push	edi
.defrag_more:
	xor	edi,edi			; edi = number of defragmentations
					; made this iteration
	mov	ebx,mem_table		; ebx ptr to the table entry to check
.main_loop:
	cmp	byte[ebx+8],MEM_STATUS_FREE
	jnz	near .main_next		; if the block is not free, try nextk
	mov	ecx,mem_table		; ecx = table entry to check against
.check_loop:
	cmp	byte[ecx+8],MEM_STATUS_FREE
	jnz	.check_next		; if block not free, try next

	mov	eax,dword[ecx]
	add	eax,dword[ecx+4]	; end of block to check against
	cmp	eax,dword[ebx]		; compare to start of first block
	jnz	.not_case0		; if not equal, try next combination
.case0:
	mov	eax,dword[ebx+4]	; size of first block
	add	dword[ecx+4],eax	; add to size of second block

	inc	edi

	; the 'ebx' block is now not used anymore, move the last
	; block of the mem_table to its place
	; and decrease mem_table_max with 9

	mov	esi,mem_table
	sub	dword[mem_table_max],9
	add	esi,dword[mem_table_max]

	mov	eax,dword[esi]
	mov	dword[ebx],eax
	mov	eax,dword[esi+4]
	mov	dword[ebx+4],eax
	mov	al,byte[esi+8]
	mov	byte[ebx+8],al

	jmp	short .main_next
.not_case0:
	mov	eax,dword[ebx]
	add	eax,dword[ebx+4]	; end of block to check
	cmp	eax,dword[ecx]		; compare to start of first
					; block to check against
	jnz	.not_case1		; if not equal, try next block
.case1:
	mov	eax,dword[ecx+4]	; size of first block
	add	dword[ebx+4],eax	; add to size of second block

	inc	edi
	; the 'ecx' block is now not used anymore, move the last
	; block of the mem_table to its place
	; and decrease mem_table_max with 9

	mov	esi,mem_table
	sub	dword[mem_table_max],9
	add	esi,dword[mem_table_max]

	mov	eax,dword[esi]
	mov	dword[ecx],eax
	mov	eax,dword[esi+4]
	mov	dword[ecx+4],eax
	mov	al,byte[esi+8]
	mov	byte[ecx+8],al

	jmp	short .main_next
.not_case1:
.check_next:
	add	ecx,9			; go to next mem_table entry
	cmp	ecx,ebx			; compare to the 'ebx' block
	jz	.check_next		; if they're the same, go to next block
	mov	eax,dword[mem_table_max]
	add	eax,mem_table		; cmp its address to end of mem_table
	cmp	ecx,eax			; if below, contunie searching
	jb	.check_loop		; else, just continue
.main_next:
	add	ebx,9			; go to next mem_table entry
	mov	eax,dword[mem_table_max]
	add	eax,mem_table		; cmp its address to end of mem_table
	cmp	ebx,eax			; if below, contunie searching
	jb	.main_loop		; else, just continue
	or	edi,edi			; was there any fragmentation?
	jnz	.defrag_more		; yup, let's go for another round
.quit:
	pop	edi
	pop	esi
	pop	ebx
	pop	edx
	pop	ecx
	pop	eax
	ret

mem_high_start	dd	0x100000
mem_high_end	dd	0x500000
mem_table_max	dd	0

