; ports.asm
;
; I/O port access from Forth.

; p@ ( port -- byte )
core_header 02,_pfetch,"p@",flag_none
_pfetch:
	mov	edx,ebx			; dx = port
	in	al,dx			; read byte
	movzx	ebx,al			; copy to TOS
	next

; p! ( byte port -- )
core_header 04,_pstore,"p!",flag_none
_pstore:
	pop	eax			; al = byte to write
	mov	edx,ebx			; dx = port
	out	dx,al			; write byte
	pop	ebx			; pop new TOS
	next

; p@block ( size block port -- )
core_header 07,_pfetchblock,"p@block",flag_none
_pfetchblock:
	mov	edx,ebx			; edx = port
	pop	ebx			; ebx = block pointer
	pop	ecx			; ecx = byte count
.next:	in	al,dx			; read byte
	mov	[ebx],al		; store to block
	inc	ebx
	loop	.next
	pop	ebx			; pop new TOS
	next

; p!block ( size block port -- )
core_header 09,_pstoreblock,"p!block",flag_none
_pstoreblock:
	mov	edx,ebx			; edx = port
	pop	ebx			; ebx = block pointer
	pop	ecx			; ecx = byte count
.next:	mov	al,[ebx]		; get byte from block
	inc	ebx
	out	dx,al			; write byte
	loop	.next
	pop	ebx			; pop new TOS
	next

