; stack.asm
;
; Words to do stack magic.

core_header 3d,_dup,"dup",flag_none
_dup:
	push	ebx
	next

core_header 08,_cdup,"?dup",flag_none
_cdup:
	or	ebx,ebx
	jz	.done
	push	ebx
.done:	next

core_header 38,_drop,"drop",flag_none
_drop:
	pop	ebx
	next

core_header 3e,_swap,"swap",flag_none
_swap:
	xchg	ebx,[esp]
	next

core_header 2c,_over,"over",flag_none
_over:
	push	ebx
	mov	ebx,[esp+4]
	next

core_header 0d,_nip,"nip",flag_none
_nip:
	add	esp,byte 4
	next

core_header 3e,_tuck,"tuck",flag_none
_tuck:
	pop	eax
	push	ebx
	push	eax
	next

core_header 14,_2dup,"2dup",flag_none
_2dup:
	push	ebx
	push	dword[esp+4]
	next

core_header 15,_2drop,"2drop",flag_none
_2drop:
	add	esp,byte 4
	pop	ebx
	next

core_header 19,_3drop,"3drop",flag_none
_3drop:
	add	esp,byte 8
	pop	ebx
	next

core_header 28,_2nip,"2nip",flag_none
_2nip:
	add	esp,byte 8
	next

core_header 16,_pick,"pick",flag_none
_pick:
	shl	ebx,2
	mov	ebx,[esp+ebx]
	next

core_header 2d,_2pick,"2pick",flag_none
_2pick:
	push	ebx
	mov	ebx,[esp+8]
	next

core_header 31,_3pick,"3pick",flag_none
_3pick:
	push	ebx
	mov	ebx,[esp+12]
	next

core_header 1e,_tor,">r",flag_none
_tor:
	xchg	ebp,esp			; use return stack
	push	ebx			; push TOS
	xchg	ebp,esp			; use data stack
	pop	ebx
	next

core_header 3f,_duptor,"dup>r",flag_none
_duptor:
	xchg	ebp,esp			; use return stack
	push	ebx			; push TOS
	xchg	ebp,esp			; use data stack
	next

core_header 06,_rto,"r>",flag_none
_rto:
	push	ebx			; drop
	xchg	ebp,esp			; use return stack
	pop	ebx			; get TOS from return stack
	xchg	ebp,esp			; use data stack
	next

core_header 0a,_rtodrop,"r>drop",flag_none
_rtodrop:
	add	ebp,byte 4
	next

core_header 0a,_rfetch,"r@",flag_none
_rfetch:
	push	ebx
	mov	ebx,[ebp]
	next

core_header 22,_r4fetch,"r+4@",flag_none
_r4fetch:
	push	ebx
	mov	ebx,[ebp+4]
	next

core_header 2e,_sp,"sp",flag_none
_sp:
	push	ebx
	mov	ebx,esp
	next

core_header 15,_sbase,"sbase",flag_none
_sbase:
	push	ebx
	mov     ebx,[proc_current]
	mov     ebx,[ebx+proc_struct.stack]
	add	ebx,[ebx-(mem_header_size-mem_header.size)]
	next

core_header 2a,_rp,"rp",flag_none
_rp:	push	ebx
	mov	ebx,ebp
	next

core_header 11,_rbase,"rbase",flag_none
_rbase:
	push	ebx
	mov     ebx,[proc_current]
	mov     ebx,[ebx+proc_struct.stack]
	mov	ebx,[ebx+mtforth_struct.rstack]
	add	ebx,[ebx-(mem_header_size-mem_header.size)]
	next

