; timer.asm
;
; Delays, but also some multitasking code.

; timer_delay
;
; ecx:eax = 64-bit value with the time to wait (in (10^-2)s units)
;
; returns:
; all registers unchanged

timer_delay:
	push	eax
	push	ecx

	add	eax,dword[timer_counter]
	adc	ecx,dword[timer_counter+4]
	; ecx:eax is now the time we should return
.not_yet:
	int	0x30
	cmp	dword[timer_counter+4],ecx
	jb	.not_yet		; if high dword is below, repeat

.not_really:
	cmp	dword[timer_counter],eax
	jb	.not_really		; wait while low word is still below

	pop	ecx
	pop	eax
	ret

; timer_handler
;
; returns:
; all registers unchanged

timer_handler:
	; increase the system counter value
	add	dword[timer_counter],byte 1
	adc	dword[timer_counter+4],byte 0

	cmp	byte[proc_mt],0		; multitasking?
	jz	.no_mt
	call	proc_switch		; yes, switch process
.no_mt:
	ret

timer_counter	dd	0,0

